/* SPARCs running Solaris 2.5.1 w/GCC tools
   at CS Dept., Princeton University */

#include <string.h>

/* Modified by Promise team: LCCDIRs replaced with NULLs */

static char rcsid[] = "$Id: gcc-solaris.c,v 1.7 2003/01/27 15:56:08 db Exp $";

#ifndef GCCDIR
#define GCCDIR "/usr/local/gnu/bin/"
#endif
#ifndef GCCLIB
#define GCCLIB "/usr/local/gnu/lib/gcc-lib/sparc-sun-solaris2.5/2.7.2/"
#endif

/* Suffix ".pi" is added by the PROMISE team */

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", ".pi", 0 };
char inputs[256] = "";
char *cpp[] = { NULL,
	"-D__STDC__=1", "-Dsparc", "-D__sparc__", "-Dsun", "-D__sun__", "-Dunix",
	"$1", "$2", "$3", 0 };
char *include[] = { NULL, "-I/usr/local/include",
	"-I" GCCLIB "include", "-I/usr/include", 0 };
char *com[] = { NULL, "-target=sparc/solaris",
	"$1", "$2", "$3", 0 };
char *as[] = { GCCDIR "as", "-f", "-o", "$3", "$1", "$2", 0 };
char *ld[] = { GCCDIR "ld", "-o", "$3", "$1",
	GCCLIB "crti.o", GCCLIB "crt1.o",
	GCCLIB "crtbegin.o", "$2", "", "", NULL, "-llcc",
	"-L" GCCLIB, "-lgcc", "-lm", "-lc", "",
	GCCLIB "crtend.o", GCCLIB "crtn.o", 0 };

/* Added by Promise team.*/

char *pass2[] = { "pass2", "$2",  "$3" , 0 };
char *promise_opt [] = { "-p", "*=ssa,cp,cse,dce", NULL, NULL };
char *promise[] = { "promise", "$1", "$2", "-o", "$3", 0 };


void init_dir ()
{
  char * LCCDIR     = getenv ("LCCDIR");
  char * PROMISEDIR = LCCDIR;
  
  if (LCCDIR     == NULL) LCCDIR     = ".";
  if (PROMISEDIR == NULL) PROMISEDIR = ".";
  
  {
    char * pcpp = (char *) malloc (strlen (LCCDIR) +  5);
    char * pcom = (char *) malloc (strlen (LCCDIR) +  5);
    char * pinc = (char *) malloc (strlen (LCCDIR) + 11);
    char * pld  = (char *) malloc (strlen (LCCDIR) +  3);

    char * ppass2   = (char *) malloc (strlen (LCCDIR) + 7);
    char * ppromise = (char *) malloc (strlen (PROMISEDIR) + 9);

    ppass2   [0] = 0;
    ppromise [0] = 0;

    strcat (ppass2, LCCDIR);
    strcat (ppass2, "/pass2");

    strcat (ppromise, PROMISEDIR);
    strcat (ppromise, "/promise");

    pass2   [0] = ppass2;
    promise [0] = ppromise;

    pcpp [0] = 0;
    pcom [0] = 0;
    pinc [0] = 0;
    pld  [0] = 0;

    strcat (pcpp, LCCDIR);
    strcat (pcpp, "/cpp");

    strcat (pcom, LCCDIR);
    strcat (pcom, "/rcc");

    strcat (pinc, "-I");
    strcat (pinc, LCCDIR);
    strcat (pinc, "/include");

    strcat (pld, "-L");
    strcat (pld, LCCDIR);

    cpp     [ 0] = pcpp;    
    com     [ 0] = pcom;
    include [ 0] = pinc;
    ld      [10] = pld;
  }
}

/* End of addition.*/

extern char *concat(char *, char *);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		ld[10] = concat("-L", &arg[8]);
		com[0] = concat(&arg[8], "/rcc");
	} else if (strcmp(arg, "-g") == 0)
		;
	else if (strcmp(arg, "-pg") == 0) {
		ld[8] = GCCLIB "gmon.o";
	} else if (strcmp(arg, "-b") == 0)
		;
	else
		return 0;
	return 1;
}
