/* SGI big endian MIPSes running IRIX 5.2 at CS Dept., Princeton University */

#include <string.h>

/* Modified by Promise team: LCCDIRs replaced with NULLs */

static char rcsid[] = "$Id: irix.c,v 1.6 2003/01/27 15:56:09 db Exp $";

/* Suffix ".pi" is added by the PROMISE team */

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", ".pi", 0 };
char inputs[256] = "";
char *cpp[] = { NULL, "-D__STDC__=1",
	"-DLANGUAGE_C",
	"-DMIPSEB",
	"-DSYSTYPE_SVR4",
	"-D_CFE",
	"-D_LANGUAGE_C",
	"-D_MIPSEB",
	"-D_MIPS_FPSET=16",
	"-D_MIPS_ISA=_MIPS_ISA_MIPS1",
	"-D_MIPS_SIM=_MIPS_SIM_ABI32",
	"-D_MIPS_SZINT=32",
	"-D_MIPS_SZLONG=32",
	"-D_MIPS_SZPTR=32",
	"-D_SGI_SOURCE",
	"-D_SVR4_SOURCE",
	"-D_SYSTYPE_SVR4",
	"-D__host_mips",
	"-D__mips=1",
	"-D__sgi",
	"-D__unix",
	"-Dhost_mips",
	"-Dmips",
	"-Dsgi",
	"-Dunix",
	"$1", "$2", "$3", 0 };
char *com[] =  { NULL, "-target=mips/irix", "$1", "$2", "$3", "", 0 };
char *include[] = { NULL, "-I/usr/local/include",
	"-I/usr/include", 0 };
char *as[] = { "/usr/bin/as", "-o", "$3", "$1", "-nocpp", "-KPIC", "$2", 0 };
char *ld[] = { "/usr/bin/ld", "-require_dynamic_link", "_rld_new_interface",
	"-elf", "-_SYSTYPE_SVR4", "-Wx,-G", "0", "-g0", "-KPIC", "-dont_warn_unused",
	"-o", "$3", "/usr/lib/crt1.o", "-L/usr/local/lib",
	"$1", "$2", "", NULL, "-llcc", "-lc", "-lm", "/usr/lib/crtn.o", 0
};

/* Added by Promise team.*/

char *pass2[] = { "pass2", "$2",  "$3" , 0 };
char *promise_opt [] = { "-p", "*=ssa,cp,cse,dce", NULL, NULL };
char *promise[] = { "promise", "$1", "$2", "-o", "$3", 0 };

void init_dir ()
{
  char * LCCDIR     = getenv ("LCCDIR");
  char * PROMISEDIR = LCCDIR;
  
  if (LCCDIR     == NULL) LCCDIR     = ".";
  if (PROMISEDIR == NULL) PROMISEDIR = ".";
  
  {
    char * ppass2   = (char *) malloc (strlen (LCCDIR) + 7);
    char * ppromise = (char *) malloc (strlen (PROMISEDIR) + 9);

    char * pcpp = (char *) malloc (strlen (LCCDIR) +  5);
    char * pcom = (char *) malloc (strlen (LCCDIR) +  5);
    char * pinc = (char *) malloc (strlen (LCCDIR) + 11);
    char * pld  = (char *) malloc (strlen (LCCDIR) +  3);

    ppass2   [0] = 0;
    ppromise [0] = 0;

    strcat (ppass2, LCCDIR);
    strcat (ppass2, "/pass2");

    strcat (ppromise, PROMISEDIR);
    strcat (ppromise, "/promise");

    pass2   [0] = ppass2;
    promise [0] = ppromise;
    pcpp [0] = 0;
    pcom [0] = 0;
    pinc [0] = 0;
    pld  [0] = 0;

    strcat (pcpp, LCCDIR);
    strcat (pcpp, "/cpp");

    strcat (pcom, LCCDIR);
    strcat (pcom, "/rcc");

    strcat (pinc, "-I");
    strcat (pinc, LCCDIR);
    strcat (pinc, "/include");

    strcat (pld, "-L");
    strcat (pld, LCCDIR);

    cpp     [ 0] = pcpp;    
    com     [ 0] = pcom;
    include [ 0] = pinc;
    ld      [17] = pld;
  }
}

/* End of addition.*/


extern char *concat(char *, char *);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		com[0] = concat(&arg[8], "/rcc");
		ld[17] = concat("-L", &arg[8]);
	} else if (strcmp(arg, "-g") == 0)
		;
	else if (strcmp(arg, "-p") == 0)
		ld[12] = "/usr/lib/mcrt1.o";
	else if (strcmp(arg, "-b") == 0)
		;
	else
		return 0;
	return 1;
}
