/*#ifndef LCCDIR
#define LCCDIR "/usr/local/lcc-4.1/x86-linux/"

#endif

x86s running Linux */

#include <string.h>
#include <stdlib.h>

/* Modified by Promise team: LCCDIRs replaced with NULLs */

static char rcsid[] = "$Id: linux.c,v 1.15 2003/01/27 15:56:09 db Exp $";

/* Suffix ".pi" is added by the PROMISE team */

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", ".pi", 0 };
char inputs[256] = "";
char *cpp[] = { NULL,
	"-U__GNUC__", "-D_POSIX_SOURCE", "-D__STDC__=1", "-D__STRICT_ANSI__",
	"-Dunix", "-Di386", "-Dlinux",
	"-D__unix__", "-D__i386__", "-D__linux__", "-D__signed__=signed",
	"$1", "$2", "$3", 0 };
char *include[] = {NULL, NULL, "-I/usr/local/include", 0 };
char *com[] = {NULL, "-target=x86/linux", "$1", "$2", "$3", 0 };
char *as[] = { "/usr/bin/as", "-o", "$3", "$1", "$2", 0 };
char *ld[] = {
	/*  0 */ "/usr/bin/ld", "-m", "elf_i386", "-dynamic-linker",
	/*  4 */ "/lib/ld-linux.so.2", "-o", "$3",
	/*  7 */ "/usr/lib/crt1.o", "/usr/lib/crti.o",
	/*  9 */ "/gcc/crtbegin.o", 
                 "$1", "$2",
	/* 12 */ "-L",
	/* 13 */ "-llcc",
	/* 14 */ "-L" "/gcc", "-lgcc", "-lc", "-lm",
	/* 18 */ "",
	/* 19 */ "/gcc/crtend.o", "/usr/lib/crtn.o",
	0 };


/* Added by Promise team.*/

char *pass2[] = { "pass2", "$2",  "$3" , 0 };
char *promise_opt [] = { "-p", "*=line,cp,cse,dce", NULL, NULL };
char *promise[] = { "promise", "$1", "$2", "-o", "$3", 0 };

void init_dir ()
{
	char * LCCDIR     = getenv ("LCCDIR");
	char * PROMISEDIR = LCCDIR;

	if (LCCDIR     == NULL) LCCDIR     = ".";
	if (PROMISEDIR == NULL) PROMISEDIR = ".";

	{
		char * pcpp     = (char *) malloc (strlen (LCCDIR) +  9);
		char * pinc1    = (char *) malloc (strlen (LCCDIR) + 11);
		char * pinc2    = (char *) malloc (strlen (LCCDIR) + 15);
		char * pcom     = (char *) malloc (strlen (LCCDIR) +  5);
		char * pld1     = (char *) malloc (strlen (LCCDIR) + 17);
		char * pld2     = (char *) malloc (strlen (LCCDIR) +  4);
		char * pld3     = (char *) malloc (strlen (LCCDIR) +  8);
		char * pld4     = (char *) malloc (strlen (LCCDIR) + 15);
		char * ppass2   = (char *) malloc (strlen (LCCDIR) +  7);
		char * ppromise = (char *) malloc (strlen (PROMISEDIR) + 9);
	
		pcpp     [0] = 0;
		pinc1    [0] = 0;
		pinc2    [0] = 0;
		pcom     [0] = 0;
		pld1     [0] = 0;
		pld2     [0] = 0;
		pld3     [0] = 0;
		pld4     [0] = 0;
		ppass2   [0] = 0;
		ppromise [0] = 0;

		strcat (pcpp, LCCDIR);
		strcat (pcpp, "/gcc/cpp");

		strcat (pinc1, "-I");
		strcat (pinc1, LCCDIR);
		strcat (pinc1, "/include");

		strcat (pinc2, "-I");
		strcat (pinc2, LCCDIR);
		strcat (pinc2, "/gcc/include");

		strcat (pcom, LCCDIR);
		strcat (pcom, "/rcc");

		strcat (pld1,  LCCDIR);
		strcat (pld1,  "/gcc/crtbegin.o");

		strcat (pld2,  "-L");
		strcat (pld2,  LCCDIR);

		strcat (pld3,  "-L");
		strcat (pld3,  LCCDIR);
		strcat (pld3,  "/gcc");

		strcat (pld4,  LCCDIR);
		strcat (pld4,  "/gcc/crtend.o");

		strcat (ppass2, LCCDIR);
		strcat (ppass2, "/pass2");
	
		strcat (ppromise, PROMISEDIR);
		strcat (ppromise, "/promise");

		cpp     [0]  = pcpp;
		include [0]  = pinc1;
		include [1]  = pinc2;
		com     [0]  = pcom;
		ld      [9]  = pld1;
		ld      [12] = pld2;
		ld      [14] = pld3;
		ld      [19] = pld4;
		pass2   [0]  = ppass2;
		promise [0]  = ppromise;
	}
}

/* End of addition. */

extern char *concat(char *, char *);

int option(char *arg) {
  	if (strncmp(arg, "-lccdir=", 8) == 0) {
//		cpp[0] = concat(&arg[8], "/gcc/cpp");
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		include[1] = concat("-I", concat(&arg[8], "/gcc/include"));
		ld[9]  = concat(&arg[8], "/gcc/crtbegin.o");
		ld[12] = concat("-L", &arg[8]);
		ld[14] = concat("-L", concat(&arg[8], "/gcc"));
		ld[19] = concat(&arg[8], "/gcc/crtend.o");
		com[0] = concat(&arg[8], "/rcc");
	} else if (strcmp(arg, "-p") == 0 || strcmp(arg, "-pg") == 0) {
		ld[7] = "/usr/lib/gcrt1.o";
		ld[18] = "-lgmon";
	} else if (strcmp(arg, "-b") == 0) 
		;
	else if (strcmp(arg, "-g") == 0)
		;
	else if (strncmp(arg, "-ld=", 4) == 0)
		ld[0] = &arg[4];
	else if (strcmp(arg, "-static") == 0) {
	        ld[3] = "-static";
	        ld[4] = "";
	} 
  	if (strncmp(arg, "-promisedir=", 8) == 0) {
		promise[0] = concat(&arg[12], "/promise");	  
	} else
		return 0;
	return 1;
}






