/* DEC ALPHAs running OSF/1 V3.2A (Rev. 17) at Princeton University */

#include <string.h>

/* Modified by Promise team: LCCDIRs replaced with NULLs */

static char rcsid[] = "$Id: osf.c,v 1.6 2003/01/27 15:56:09 db Exp $";

/* Suffix ".pi" is added by the PROMISE team */

char *suffixes[] = { ".c", ".i", ".s", ".o", ".out", ".pi", 0 };
char inputs[256] = "";
char *cpp[] = {
	NULL, "-D__STDC__=1",
	"-DLANGUAGE_C", "-D__LANGUAGE_C__",
 	"-D_unix", "-D__unix__", "-D_osf", "-D__osf__", "-Dunix",
	"-Dalpha", "-D_alpha", "-D__alpha",
	"-D__SYSTYPE_BSD",  "-D_SYSTYPE_BSD",
	"$1", "$2", "$3", 0 };
char *com[] =  { NULL, "-target=alpha/osf", "$1", "$2", "$3", "", 0 };
char *include[] = { NULL, "-I/usr/local/include",
	"-I/usr/include", 0 };
char *as[] =  { "/bin/as", "-o", "$3", "", "$1", "-nocpp", "$2", 0 };
char *ld[] =  { "/usr/bin/ld", "-o", "$3", "/usr/lib/cmplrs/cc/crt0.o",
	"$1", "$2", "", "", NULL, "-llcc", "-lm", "-lc", 0 };

/* Added by Promise team.*/

char *pass2[] = { "pass2", "$2",  "$3" , 0 };
char *promise_opt [] = { "-p", "*=ssa,cp,cse,dce", NULL, NULL };
char *promise[] = { "promise", "$1", "$2", "-o", "$3", 0 };

void init_dir ()
{
  char * LCCDIR     = getenv ("LCCDIR");
  char * PROMISEDIR = LCCDIR;
  
  if (LCCDIR     == NULL) LCCDIR     = ".";
  if (PROMISEDIR == NULL) PROMISEDIR = ".";
  
  {
    char * pcpp = (char *) malloc (strlen (LCCDIR) +  5);
    char * pcom = (char *) malloc (strlen (LCCDIR) +  5);
    char * pinc = (char *) malloc (strlen (LCCDIR) + 11);
    char * pld  = (char *) malloc (strlen (LCCDIR) +  3);

    char * ppass2   = (char *) malloc (strlen (LCCDIR) + 7);
    char * ppromise = (char *) malloc (strlen (PROMISEDIR) + 9);

    ppass2   [0] = 0;
    ppromise [0] = 0;

    strcat (ppass2, LCCDIR);
    strcat (ppass2, "/pass2");

    strcat (ppromise, PROMISEDIR);
    strcat (ppromise, "/promise");

    pass2   [0] = ppass2;
    promise [0] = ppromise;

    pcpp [0] = 0;
    pcom [0] = 0;
    pinc [0] = 0;
    pld  [0] = 0;

    strcat (pcpp, LCCDIR);
    strcat (pcpp, "/cpp");

    strcat (pcom, LCCDIR);
    strcat (pcom, "/rcc");

    strcat (pinc, "-I");
    strcat (pinc, LCCDIR);
    strcat (pinc, "/include");

    strcat (pld, "-L");
    strcat (pld, LCCDIR);

    cpp     [0] = pcpp;    
    com     [0] = pcom;
    include [0] = pinc;
    ld      [8] = pld;
  }
}

/* End of addition.*/

extern char *concat(char *, char *);
extern int access(const char *, int);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		com[0] = concat(&arg[8], "/rcc");
		ld[8] = concat("-L", &arg[8]);
	} else if (strcmp(arg, "-g4") == 0
	&& access("/u/drh/lib/alpha/rcc", 4) == 0
	&& access("/u/drh/book/cdb/alpha/osf/cdbld", 4) == 0) {
		com[0] = "/u/drh/lib/alpha/rcc";
		com[5] = "-g4";
		ld[0] = "/u/drh/book/cdb/alpha/osf/cdbld";
		ld[1] = "-o";
		ld[2] = "$3";
		ld[3] = "$1";
		ld[4] = "$2";
		ld[5] = 0;
	} else if (strcmp(arg, "-g") == 0)
		return 1;
	else if (strcmp(arg, "-b") == 0)
		;
	else
		return 0;
	return 1;
}
