/* x86s running MS Windows NT 4.0 */

#include <string.h>
#include <stdlib.h>

static char rcsid[] = "$Id: win32.c,v 1.11 2003/02/05 11:32:33 db Exp $";

/* Modified by Promise team: LCCDIRs replaced with NULLs */

char *suffixes[] = { ".c;.C", ".i;.I", ".asm;.ASM;.s;.S", ".obj;.OBJ", ".exe", ".pi",  0 };
char inputs[256] = "";
char *cpp[] = { NULL, "-D__STDC__=1", "-Dwin32", "-D_WIN32", "-D_M_IX86",
	"$1", "$2", "$3", 0 };
char *include[] = { NULL, 0 };
char *com[] = { NULL, "-target=x86/win32", "$1", "$2", "$3", 0 };
char *as[] = { "ml", "-nologo", "-c", "-Cp", "-coff", "-Fo$3", "$1", "$2", 0 };
char *ld[] = { "link", "-nologo", 
	"-align:0x1000", "-subsystem:console", "-entry:mainCRTStartup",
	"$2", "-OUT:$3", "$1", NULL, "libc.lib", "kernel32.lib", 0 };
char *pass2[] = { "pass2", "$2",  "$3" , 0 };
char *promise_opt [] = { "-p", "*=ssa,cp,cse,dce", NULL, NULL };
char *promise[] = { "promise", "$1", "$2", "-o", "$3", 0 };

extern char *concat(char *, char *);
extern char *replace(const char *, int, int);

/* Added by Promise team.*/

void init_dir ()
{
	char * LCCDIR     = getenv ("LCCDIR");
	char * PROMISEDIR = LCCDIR;
	char * MSVCDIR    = getenv ("MSVCDir");

	if (LCCDIR     == NULL) LCCDIR     = "";
	if (PROMISEDIR == NULL) PROMISEDIR = "";
	if (MSVCDIR    == NULL) MSVCDIR = "";

	{
		char * pcpp     = (char *) malloc (strlen (LCCDIR) +  10);
		char * pinc     = (char *) malloc (strlen (MSVCDIR) + 11);
		char * pcom     = (char *) malloc (strlen (LCCDIR) +  10);
		char * pld      = (char *) malloc (strlen (LCCDIR) + 12);
		char * ppass2   = (char *) malloc (strlen (LCCDIR) + 15);
		char * ppromise = (char *) malloc (strlen (PROMISEDIR) + 15);
	
		pcpp     [0] = 0;
		pinc     [0] = 0;
		pcom     [0] = 0;
		pld      [0] = 0;
		ppass2   [0] = 0;
		ppromise [0] = 0;

		strcat (pcpp, LCCDIR);
		strcat (pcpp, "\\cpp.exe");

		strcat (pinc, "-I ");
		strcat (pinc, MSVCDIR);
		strcat (pinc, "\\include");

		strcat (pcom, LCCDIR);
		strcat (pcom, "\\rcc.exe");

		strcat (pld,  LCCDIR);
		strcat (pld,  "\\liblcc.lib");
	
		strcat (ppass2,  LCCDIR);
		strcat (ppass2,  "\\pass2.exe");

		strcat (ppromise,  PROMISEDIR);
		strcat (ppromise,  "\\promise.exe");

		cpp     [0] = pcpp;
		include [0] = pinc;
		com     [0] = pcom;
		ld      [8] = pld;
		pass2   [0] = ppass2;
		promise [0] = ppromise;
	}
}

/* End of addition. */

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		arg = replace(arg + 8, '/', '\\');
		if (arg[strlen(arg)-1] == '\\')
			arg[strlen(arg)-1] = '\0';
		cpp[0] = concat(arg, "\\cpp.exe");
		include[0] = concat("-I", concat(arg, "\\include"));
		com[0] = concat(arg, "\\rcc.exe");
		ld[8] = concat(arg, "\\liblcc.lib");
	} else if (strcmp(arg, "-b") == 0)
		;
	else if (strncmp(arg, "-ld=", 4) == 0)
		ld[0] = &arg[4];
	else
		return 0;
	return 1;
}



